--		Zaglavlje fajla --------------------------------------------------------
--       Naziv 5csadd - Petobitni sabirac sa uslovnim sumama
--   		 Opis Sabira dva petobitna broja, tako sto paralelno sabira bit po 
--				   bit, i to u slucaju ulaznog prenosa 0 i 1, a onda po izracuna-
--					vanju ulaznog prenosa koristi jedan od dva izracunata rezultata
--        Fajl C:\My Documents\etf\ri5vlsi\domaci\mk2002\sabirac\vhdl\sabirac\
--					SRC\5csadd.VHD
--		  Namena Domaci zadatak iz predmeta racunarski VLSI sistemi
--    Napomene U realnosti kasnjenje kroz and,or,xor i xnor kola nije isto,ali
--					 je ta pretpostavka uvedena u postavci zadatka.
-- Ogranicenja -
--      Greske -
--   Korisceni
--  	  paketi IEEE.std_logic_1164
--       Autor Milos Kovacevic, pirate@bitsyu.net, http://pirate.jump.to
--   Korisceni
--	  simulator Active VHDL 3.2 build 207
--     Verzija 1.00 (29/01/2002)
--      Izmene 
-------------------------------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;

entity \5csadd\ is
--		Zaglavlje entiteta ------------------------------------------------------
--         Opis Entitet petobitnog sabiraca, sadrzi dva ulazna porta za sabirke
--					 ulazni prenos, izlazni petobitni zbir i izlazni prenos.
--  Ogranicenja -
-- Pretpostavke Tk je isto za sva logicka kola, i iznosi 2ns
--      Verzija 1.00
--       Izmene -
--        Autor Milos Kovacevic, pirate@bitsyu.net, http://pirate.jump.to
--        Datum 29/01/2002
-------------------------------------------------------------------------------
	generic (
		Tprop:time:=2ns 		-- vreme kasnjenja jednog logickog kola
	);
   port (
      A:   in  STD_LOGIC_VECTOR (4 downto 0); -- prvi petobitni sabirak
      Cin: in  STD_LOGIC;							 -- ulazni prenos
      B:   in  STD_LOGIC_VECTOR (4 downto 0); -- drugi petobitni sabirak
      
      S:   out STD_LOGIC_VECTOR (4 downto 0); -- petobitni zbir
      C5:  out STD_LOGIC							 -- izlazni prenos
   );
end \5csadd\;

architecture mk5csadd001struct of \5csadd\ is
--		Zaglavlje arhitekture ---------------------------------------------------
--         Opis Arhitektura strukture petobitnog sabiraca. Brojevi se sabiraju
--					 tako sto paralelno sabira bit po bit svakog razreda, i to u 
--					 slucaju ulaznog prenosa 0 i 1, a onda po izracunavanju tog 
--					 ulaznog prenosa koristi jedan od dva izracunata rezultata.
--  Ogranicenja Izlaz ima validnu vrednost tek posle kasnjenja od 10*Tk
-- Pretpostavke Kasnjenje je isto za sva logicka kola. 
--      Verzija 1.00
--       Izmene -
--        Autor Milos Kovacevic, pirate@bitsyu.net, http://pirate.jump.to
--        Datum 29/01/2002
-------------------------------------------------------------------------------
	signal C1_0:  STD_LOGIC;	-- prenos iz 0. u 1. razred pod uslovom C0=0
	signal S0_0:  STD_LOGIC;	-- zbir 0. razreda pod uslovom C0=0
	signal C1_1:  STD_LOGIC;	-- prenos iz 0. u 1. razred pod uslovom C0=1
	signal S0_1:  STD_LOGIC;	-- zbir 0. razreda pod uslovom C0=1
	signal C2_0:  STD_LOGIC;	-- prenos iz 1. u 2. razred pod uslovom C1=0
	signal S1_0:  STD_LOGIC;	-- zbir 1. razreda pod uslovom C1=0
	signal C2_1:  STD_LOGIC;	-- prenos iz 1. u 2. razred pod uslovom C1=1
	signal S1_1:  STD_LOGIC;	-- zbir 1. razreda pod uslovom C1=1
	signal C3_0:  STD_LOGIC;	-- prenos iz 2. u 3. razred pod uslovom C2=0
	signal S2_0:  STD_LOGIC;	-- zbir 2. razreda pod uslovom C2=0
	signal C3_1:  STD_LOGIC;	-- prenos iz 2. u 3. razred pod uslovom C2=1
	signal S2_1:  STD_LOGIC;	-- zbir 2. razreda pod uslovom C2=1
	signal C4_0:  STD_LOGIC;	-- prenos iz 3. u 4. razred pod uslovom C3=0
	signal S3_0:  STD_LOGIC;	-- zbir 3. razreda pod uslovom C3=0
	signal C4_1:  STD_LOGIC;	-- prenos iz 3. u 4. razred pod uslovom C3=1
	signal S3_1:  STD_LOGIC;	-- zbir 3. razreda pod uslovom C3=1
	signal C5_0:  STD_LOGIC;	-- prenos iz 4. u 5. razred pod uslovom C4=0
	signal S4_0:  STD_LOGIC;	-- zbir 4. razreda pod uslovom C4=0
	signal C5_1:  STD_LOGIC;	-- prenos iz 4. u 5. razred pod uslovom C4=1
	signal S4_1:  STD_LOGIC;	-- zbir 4. razreda pod uslovom C4=1

	signal C3_X0: STD_LOGIC;	-- prenos iz 2. u 3. razred pod uslovom C1=0
	signal S2_X0: STD_LOGIC;	-- zbir 2. razreda pod uslovom C1=0
	signal C3_X1: STD_LOGIC;	-- prenos iz 2. u 3. razred pod uslovom C1=1
	signal S2_X1: STD_LOGIC;	-- zbir 2. razreda pod uslovom C1=1
	signal C5_X0: STD_LOGIC;	-- prenos iz 4. u 5. razred pod uslovom C3=0
	signal S4_X0: STD_LOGIC;	-- zbir 4. razreda pod uslovom C3=0
	signal C5_X1: STD_LOGIC;	-- prenos iz 4. u 5. razred pod uslovom C3=1
	signal S4_X1: STD_LOGIC;	-- zbir 4. razreda pod uslovom C3=1

	signal C1:    STD_LOGIC;	-- prenos iz 0. u 1. razred
	signal C3:    STD_LOGIC;	-- prenos iz 2. u 3. razred

begin
	cadd0: entity cadd(caddbeh)-- kreiranje instance sabiraca 0. razreda
		generic map (
			Tk => Tprop				-- ovde se precizira kasnjenje Tk
		)
		port map (					
			A  => A(0),				-- veze signala na portove su logicne
			B  => B(0),				-- na osnovu objasnjenja uloge signala
			C0 => C1_0,
			S0 => S0_0,
			C1 => C1_1,
			S1 => S0_1
		);
	cadd1: entity cadd(caddbeh)-- kreiranje instance sabiraca 1. razreda
		generic map (
			Tk => Tprop
		)
		port map (
			A  => A(1),
			B  => B(1),
			C0 => C2_0,
			S0 => S1_0,
			C1 => C2_1,
			S1 => S1_1
		);
	cadd2: entity cadd(caddbeh)-- kreiranje instance sabiraca 2. razreda
		generic map (
			Tk => Tprop
		)
		port map (
			A  => A(2),
			B  => B(2),
			C0 => C3_0,
			S0 => S2_0,
			C1 => C3_1,
			S1 => S2_1
		);
	cadd3: entity cadd(caddbeh)-- kreiranje instance sabiraca 3. razreda
		generic map (
			Tk => Tprop
		)
		port map (
			A  => A(3),
			B  => B(3),
			C0 => C4_0,
			S0 => S3_0,
			C1 => C4_1,
			S1 => S3_1
		);
	cadd4: entity cadd(caddbeh)-- kreiranje instance sabiraca 4. razreda
		generic map (
			Tk => Tprop
		)
		port map (
			A  => A(4),
			B  => B(4),
			C0 => C5_0,
			S0 => S4_0,
			C1 => C5_1,
			S1 => S4_1
		);
		
-- kreiranje instanci dvobitnih dvoulaznih multipleksera koji biraju
-- rezultate uslovnih sabiraca na osnovu vrednosti prenosa u dati razred
	mux2x2_0: entity mux2xn(mux2xnbeh)
		generic map (
			Tk => Tprop,			-- ovde se precizira kasnjenje Tk
			n  => 2					-- sirina ulaznih signala je 2
		)
		port map (
			A(0) => C1_0,			-- veze signala na portove su logicne
			A(1) => S0_0,			-- na osnovu objasnjenja uloge signala
			B(0) => C1_1,			-- i ovog multipleksera
			B(1) => S0_1,
			s	  => Cin,
			Y(0) => C1,
			Y(1) => S(0)	
		);
	mux2x2_1: entity mux2xn(mux2xnbeh)
		generic map (
			Tk => Tprop,
			n  => 2
		)
		port map (
			A(0) => C3_0,
			A(1) => S2_0,
			B(0) => C3_1,
			B(1) => S2_1,
			s	  => C2_0,
			Y(0) => C3_X0,
			Y(1) => S2_X0	
		);
	mux2x2_2: entity mux2xn(mux2xnbeh)
		generic map (
			Tk => Tprop,
			n  => 2
		)
		port map (
			A(0) => C3_0,
			A(1) => S2_0,
			B(0) => C3_1,
			B(1) => S2_1,
			s	  => C2_1,
			Y(0) => C3_X1,
			Y(1) => S2_X1	
		);
	mux2x2_3: entity mux2xn(mux2xnbeh)
		generic map (
			Tk => Tprop,
			n  => 2
		)
		port map (
			A(0) => C5_0,
			A(1) => S4_0,
			B(0) => C5_1,
			B(1) => S4_1,
			s	  => C4_0,
			Y(0) => C5_X0,
			Y(1) => S4_X0	
		);
	mux2x2_4: entity mux2xn(mux2xnbeh)
		generic map (
			Tk => Tprop,
			n  => 2
		)
		port map (
			A(0) => C5_0,
			A(1) => S4_0,
			B(0) => C5_1,
			B(1) => S4_1,
			s	  => C4_1,
			Y(0) => C5_X1,
			Y(1) => S4_X1	
		);
		
-- trobitni dvoulazni multiplekser koji bira rezultate 1. i 2. razreda
-- na osnovu vrednosti prenosa u prvi razred - C1.
	mux2x3_0: entity mux2xn(mux2xnbeh)
		generic map (
			Tk => Tprop,			-- ovde se precizira kasnjenje Tk
			n  => 3					-- sirina ulaznih signala je 2
		)
		port map (					
			A(0) => S1_0,			-- veze signala na portove su logicne
			A(1) => C3_X0,			-- na osnovu objasnjenja uloge signala
			A(2) => S2_X0,			-- i ovog multipleksera
			B(0) => S1_1,
			B(1) => C3_X1,
			B(2) => S2_X1,
			s	  => C1,
			Y(0) => S(1),
			Y(1) => C3,
			Y(2) => S(2)	
		);
-- trobitni dvoulazni multiplekser koji bira rezultate 3. i 4. razreda
-- na osnovu vrednosti prenosa u treci razred - C3.
	mux2x3_1: entity mux2xn(mux2xnbeh)
		generic map (
			Tk => Tprop,			-- ovde se precizira kasnjenje Tk
			n  => 3					-- sirina ulaznih signala je 2
		)
		port map (
			A(0) => S3_0,			-- veze signala na portove su logicne
			A(1) => C5_X0,			-- na osnovu objasnjenja uloge signala
			A(2) => S4_X0,			-- i ovog multipleksera
			B(0) => S3_1,
			B(1) => C5_X1,
			B(2) => S4_X1,
			s	  => C3,
			Y(0) => S(3),
			Y(1) => C5,
			Y(2) => S(4)	
		);
		
end architecture mk5csadd001struct;
