--		Zaglavlje fajla --------------------------------------------------------
--       Naziv adderTestBench - Test za sabirac
--   		 Opis Proverava izlaze sabiraca za granicne slucajeve ulaza.
--        Fajl C:\My Documents\etf\ri5vlsi\domaci\mk2002\sabirac\vhdl\sabirac\
--					SRC\adderTestBench.VHD
--		  Namena Za testiranje 5csadd sabiraca
--    Napomene -
-- Ogranicenja -
--      Greske -
--   Korisceni
--  	  paketi IEEE.std_logic_1164
--       Autor Milos Kovacevic, pirate@bitsyu.net, http://pirate.jump.to
--   Korisceni
--	  simulator Active VHDL 3.2 build 207
--     Verzija 1.00 (31/01/2002)
--      Izmene 
-------------------------------------------------------------------------------
library IEEE;
use IEEE.std_logic_1164.all;

entity adderTestBench is
--		Zaglavlje entiteta ------------------------------------------------------
--         Opis Kao i svi entiteti za TestBench i ovaj nema portove
--  Ogranicenja -
-- Pretpostavke -
--      Verzija 1.00
--       Izmene -
--        Autor Milos Kovacevic, pirate@bitsyu.net, http://pirate.jump.to
--        Datum 31/01/2002
-------------------------------------------------------------------------------
end entity adderTestBench;

architecture test1 of adderTestBench is
--		Zaglavlje arhitekture ---------------------------------------------------
--         Opis Na ulaze sabiraca dovodima iste test vektore koji su korisceni
--					 i pri testiranju u alteri.
--  Ogranicenja 
-- Pretpostavke 
--      Verzija 1.00
--       Izmene -
--        Autor Milos Kovacevic, pirate@bitsyu.net, http://pirate.jump.to
--        Datum 31/01/2002
-------------------------------------------------------------------------------
	signal X : std_logic_vector (4 downto 0);	-- prvi test sabirak
	signal C0: std_logic;							-- ulazni test prenos
	signal Y : std_logic_vector (4 downto 0);	-- drugi test sabirak
	
	signal Z : std_logic_vector (4 downto 0);	-- test zbir
	signal C5: std_logic;							-- izlazni test prenos

begin
	-- kreiranje instance sabiraca koji se testira
	adder: entity \5csadd\ (mk5csadd001struct)
		port map (
			A   => X,
			Cin => C0,
			B   => Y,
			S   => Z,
			C5  => C5
		);
		
	granicniTest: process is
	begin
		-- sada sledi primenjivanje istih test vektora kao i u alteri, i
		-- provera dobijenih rezultata
		X <= "00000";
		Y <= "00000";
		C0 <= '0';
		wait for 50ns;
		assert (Z="00000") and (C5='0') -- ocekivani rezultati
			-- poruka za ispis u slucaju greske:
			report "Greska pri sabiranju 0 i 0, uz C0=0"; 
		C0 <= '1';
		wait for 50ns;
		assert (Z="00001") and (C5='0')
			report "Greska pri sabiranju 0 i 0, uz C0=1";
		X  <= "00001";
		C0 <= '0';
		wait for 50ns;
		assert (Z="00001") and (C5='0')
			report "Greska pri sabiranju 1 i 0, uz C0=0";
		X <= "00000";
		Y <= "00001";
		wait for 50ns;
		assert (Z="00001") and (C5='0')
			report "Greska pri sabiranju 0 i 1, uz C0=0";
		X <= "01010";
		Y <= "10110";
		C0<= '1';
		wait for 50ns;
		assert (Z="00001") and (C5='1')
			report "Greska pri sabiranju 10 i 22, uz C0=1";
		X <= "01100";
		Y <= "00111";	
		C0<= '0';
		wait for 50ns;
		assert (Z="10011") and (C5='0')
			report "Greska pri sabiranju 12 i 7, uz C0=0";
		X <= "10000";
		Y <= "00000";	
		C0<= '1';
		wait for 50ns;
		assert (Z="10001") and (C5='0')
			report "Greska pri sabiranju 16 i 0, uz C0=1";
		X <= "11110";
		Y <= "10000";	
		C0<= '0';
		wait for 50ns;
		assert (Z="01110") and (C5='1')
			report "Greska pri sabiranju 30 i 16, uz C0=0";
		X <= "11111";
		Y <= "11111";	
		C0<= '1';
		wait for 50ns;
		assert (Z="11111") and (C5='1')
			report "Greska pri sabiranju 31 i 31, uz C0=1";
		wait;
	end process granicniTest;
end architecture test1;
