--		Zaglavlje fajla --------------------------------------------------------
--       Naziv cadd - Conditional ADDer
--   		 Opis Uslovni jednobitni sabirac.Daje zbir i prenos pod pretpostavkom
--				   da je ulazni prenos 0 (S0 i C0), odnosno 1 (S1 i C1).
--        Fajl C:\My Documents\etf\ri5vlsi\domaci\mk2002\sabirac\vhdl\sabirac\
--					SRC\cadd.VHD
--		  Namena Koristi se kao blok u 5bit sabiracu sa uslovnim sumama.
--    Napomene U realnosti kasnjenje kroz and,or,xor i xnor kola nije isto,ali
--					je ta pretpostavka uvedena u postavci zadatka.
-- Ogranicenja Kasnjenje kroz logicko kolo Tk se mora precizirati pri
--					pravljenju instance ove komponente na visem nivou, u
--				   generic mapi.
--      Greske -
--   Korisceni
--  	  paketi IEEE.std_logic_1164
--       Autor Milos Kovacevic, pirate@bitsyu.net, http://pirate.jump.to
--   Korisceni
--	  simulator Active VHDL 3.2 build 207
--     Verzija 1.01 (29/01/2002)
--      Izmene Izbacen proces i ubacene konkurentne dodele vrednosti.
-------------------------------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;

entity cadd is
--		Zaglavlje entiteta ------------------------------------------------------
--         Opis Entitet uslovnog jednobitnog sabiraca, sadrzi dva ulazna bita
--					 (sabirka) i izlazne, uslovne sume i prenose
--  Ogranicenja Tk - vreme kasnjenja se mora precizirati
-- Pretpostavke Tk je isto za sva logicka kola 
--      Verzija 1.00
--       Izmene -
--        Autor Milos Kovacevic, pirate@bitsyu.net, http://pirate.jump.to
--        Datum 29/01/2002
-------------------------------------------------------------------------------
	generic (
		Tk:time					-- vreme kasnjenja jednog logickog kola
	);
   port (
      A:  in  STD_LOGIC;	-- prvi sabirak (bit)
      B:  in  STD_LOGIC;	-- drugi sabirak (bit)
      
      C0: out STD_LOGIC;	-- Carry out pod uslovom Cin=0
      S0: out STD_LOGIC;	-- zbir pod uslovom Cin=0
      C1: out STD_LOGIC;	-- Carry out pod uslovom Cin=1
      S1: out STD_LOGIC		-- zbir pod uslovom Cin=1
   );
end cadd;

architecture caddbeh of cadd is
--		Zaglavlje arhitekture ---------------------------------------------------
--         Opis Arhitektura ponasanja uslovnog jednobitnog sabiraca, vrlo
--					 pazljivo isprojektovana i testirana.
--  Ogranicenja -
-- Pretpostavke Kasnjenje je isto za and, xor, or i xnor logicka kola. 
--      Verzija 1.01
--       Izmene Izbacen proces i ubacene konkurentne dodele vrednosti.
--        Autor Milos Kovacevic, pirate@bitsyu.net, http://pirate.jump.to
--        Datum 29/01/2002
-------------------------------------------------------------------------------
begin
   C0 <= A and  B  after Tk;	--  Ovo su konkurentne dodele vrednosti signalima
   S0 <= A xor  B  after Tk;  --  aktiviraju se automatski pri promeni bilo kog
  	C1 <= A or   B  after Tk;  --  signala sa desne strane ovih izraza, u ovom 
   S1 <= A xnor B  after Tk; 	--  slucaju A ili B.
end architecture caddbeh;
